Index: /palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- /palm/trunk/SOURCE/advec_ws.f90	(revision 2231)
+++ /palm/trunk/SOURCE/advec_ws.f90	(revision 2232)
@@ -20,5 +20,8 @@
 ! Current revisions:
 ! ------------------
-! 
+! Rename wall_flags_0 and wall_flags_00 into advc_flags_1 and advc_flags_2, 
+! respectively.
+! Set advc_flags_1/2 on basis of wall_flags_0/00 instead of nzb_s/u/v/w_inner.
+! Setting advc_flags_1/2 also for downward-facing walls
 ! 
 ! Former revisions:
@@ -147,5 +150,5 @@
 ! vector version.
 ! Degradation of the applied order of scheme is now steered by multiplying with
-! Integer wall_flags_0. 2nd order scheme, WS3 and WS5 are calculated on each
+! Integer advc_flags_1. 2nd order scheme, WS3 and WS5 are calculated on each
 ! grid point and mulitplied with the appropriate flag.
 ! 2nd order numerical dissipation term changed. Now the appropriate 2nd order
@@ -406,7 +409,6 @@
 
        USE indices,                                                            &
-           ONLY:  nbgp, nxl, nxlu, nxr, nyn, nys, nysv, nzb, nzb_s_inner,      &
-                  nzb_u_inner, nzb_v_inner, nzb_w_inner, nzt, wall_flags_0,    &
-                  wall_flags_00
+           ONLY:  advc_flags_1, advc_flags_2, nbgp, nxl, nxlu, nxr, nyn, nys,  &
+                  nysv, nzb, nzt, wall_flags_0
 
        USE kinds
@@ -414,8 +416,11 @@
        IMPLICIT NONE
 
-       INTEGER(iwp) ::  i  !< index variable along x
-       INTEGER(iwp) ::  j  !< index variable along y
-       INTEGER(iwp) ::  k  !< index variable along z
-
+       INTEGER(iwp) ::  i     !< index variable along x
+       INTEGER(iwp) ::  j     !< index variable along y
+       INTEGER(iwp) ::  k     !< index variable along z
+       INTEGER(iwp) ::  k_mm  !< dummy index along z
+       INTEGER(iwp) ::  k_pp  !< dummy index along z
+       INTEGER(iwp) ::  k_ppp !< dummy index along z
+       
        LOGICAL      ::  flag_set !< steering variable for advection flags
    
@@ -425,90 +430,134 @@
 !--       Set flags to steer the degradation of the advection scheme in advec_ws
 !--       near topography, inflow- and outflow boundaries as well as bottom and
-!--       top of model domain. wall_flags_0 remains zero for all non-prognostic
+!--       top of model domain. advc_flags_1 remains zero for all non-prognostic
 !--       grid points.
           DO  i = nxl, nxr
              DO  j = nys, nyn
-                DO  k = nzb_s_inner(j,i)+1, nzt
+                DO  k = nzb+1, nzt
 !
 !--                scalar - x-direction
 !--                WS1 (0), WS3 (1), WS5 (2)
-                   IF ( ( k <= nzb_s_inner(j,i+1) .OR. k <= nzb_s_inner(j,i+2) &   
-                     .OR. k <= nzb_s_inner(j,i-1) )                            &
-                       .OR. ( ( inflow_l .OR. outflow_l .OR. nest_bound_l )    &
-                              .AND. i == nxl   )    .OR.                       &
+                   IF ( ( .NOT. BTEST(wall_flags_0(k,j,i+1),0)                 &
+                    .OR.  .NOT. BTEST(wall_flags_0(k,j,i+2),0)                 &   
+                    .OR.  .NOT. BTEST(wall_flags_0(k,j,i-1),0) )               &
+                      .OR.  ( ( inflow_l .OR. outflow_l .OR. nest_bound_l )    &
+                            .AND.  i == nxl   )                                &
+                      .OR.  ( ( inflow_r .OR. outflow_r .OR. nest_bound_r )    &
+                            .AND.  i == nxr   ) )                              &
+                   THEN
+                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 0 )
+                   ELSEIF ( ( .NOT. BTEST(wall_flags_0(k,j,i+3),0)             &
+                       .AND.        BTEST(wall_flags_0(k,j,i+1),0)             &
+                       .AND.        BTEST(wall_flags_0(k,j,i+2),0)             &
+                       .AND.        BTEST(wall_flags_0(k,j,i-1),0)             &
+                            )                       .OR.                       &
+                            ( .NOT. BTEST(wall_flags_0(k,j,i-2),0)             &
+                       .AND.        BTEST(wall_flags_0(k,j,i+1),0)             &
+                       .AND.        BTEST(wall_flags_0(k,j,i+2),0)             &
+                       .AND.        BTEST(wall_flags_0(k,j,i-1),0)             &
+                            )                                                  &
+                                                    .OR.                       &
                             ( ( inflow_r .OR. outflow_r .OR. nest_bound_r )    &
-                              .AND. i == nxr   ) )                             &
+                              .AND. i == nxr-1 )    .OR.                       &
+                            ( ( inflow_l .OR. outflow_l .OR. nest_bound_l )    &
+                              .AND. i == nxlu  ) )                             &
                    THEN
-                      wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 0 )
-                   ELSEIF ( ( k <= nzb_s_inner(j,i+3) .AND. k > nzb_s_inner(j,i+1)&
-                                                      .AND. k > nzb_s_inner(j,i+2)&
-                                                      .AND. k > nzb_s_inner(j,i-1)&
-                            )                       .OR.                          &
-                            ( k <= nzb_s_inner(j,i-2) .AND. k > nzb_s_inner(j,i+1)&
-                                                      .AND. k > nzb_s_inner(j,i+2)&
-                                                      .AND. k > nzb_s_inner(j,i-1)&
-                            )                                                     &
-                                                    .OR.                          &
-                            ( ( inflow_r .OR. outflow_r .OR. nest_bound_r )       &
-                              .AND. i == nxr-1 )    .OR.                          &
-                            ( ( inflow_l .OR. outflow_l .OR. nest_bound_l )       &
-                              .AND. i == nxlu  ) )                                &
-                   THEN
-                      wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 1 )
-                   ELSEIF ( k > nzb_s_inner(j,i+1) .AND. k > nzb_s_inner(j,i+2)&
-                      .AND. k > nzb_s_inner(j,i+3) .AND. k > nzb_s_inner(j,i-1)&
-                      .AND. k > nzb_s_inner(j,i-2) )                           &
+                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 1 )
+                   ELSEIF ( BTEST(wall_flags_0(k,j,i+1),0)                     &
+                      .AND. BTEST(wall_flags_0(k,j,i+2),0)                     &
+                      .AND. BTEST(wall_flags_0(k,j,i+3),0)                     &
+                      .AND. BTEST(wall_flags_0(k,j,i-1),0)                     &
+                      .AND. BTEST(wall_flags_0(k,j,i-2),0) )                   &
                    THEN 
-                      wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 2 )
+                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 2 )
                    ENDIF
 !
 !--                scalar - y-direction
 !--                WS1 (3), WS3 (4), WS5 (5)
-                   IF ( ( k <= nzb_s_inner(j+1,i)  .OR. k <= nzb_s_inner(j+2,i)   &   
-                                                   .OR. k <= nzb_s_inner(j-1,i) ) &
-                                                    .OR.                          &
-                            ( ( inflow_s .OR. outflow_s .OR. nest_bound_s )       &
-                              .AND. j == nys   )    .OR.                          &
-                            ( ( inflow_n .OR. outflow_n .OR. nest_bound_n )       &
-                              .AND. j == nyn   ) )                                &
+                   IF ( ( .NOT. BTEST(wall_flags_0(k,j+1,i),0)                 &
+                    .OR.  .NOT. BTEST(wall_flags_0(k,j+2,i),0)                 &   
+                    .OR.  .NOT. BTEST(wall_flags_0(k,j-1,i),0))                &
+                      .OR.  ( ( inflow_s .OR. outflow_s .OR. nest_bound_s )    &
+                            .AND.  j == nys   )                                &
+                      .OR.  ( ( inflow_n .OR. outflow_n .OR. nest_bound_n )    &
+                            .AND.  j == nyn   ) )                              &
                    THEN
-                      wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 3 )
+                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 3 )
 !
 !--                WS3
-                   ELSEIF ( ( k <= nzb_s_inner(j+3,i) .AND. k > nzb_s_inner(j+1,i)&
-                                                      .AND. k > nzb_s_inner(j+2,i)&
-                                                      .AND. k > nzb_s_inner(j-1,i)&
-                            )                           .OR.                      &
-                            ( k <= nzb_s_inner(j-2,i) .AND. k > nzb_s_inner(j+1,i)&
-                                                      .AND. k > nzb_s_inner(j+2,i)&
-                                                      .AND. k > nzb_s_inner(j-1,i)&
-                            )                                                     &
-                                                        .OR.                      &
-                            ( ( inflow_s .OR. outflow_s .OR. nest_bound_s )       &
-                              .AND. j == nysv  )    .OR.                          &
-                            ( ( inflow_n .OR. outflow_n .OR. nest_bound_n )       &
-                              .AND. j == nyn-1 ) )                                &
+                   ELSEIF ( ( .NOT. BTEST(wall_flags_0(k,j+3,i),0)             &
+                       .AND.        BTEST(wall_flags_0(k,j+1,i),0)             &
+                       .AND.        BTEST(wall_flags_0(k,j+2,i),0)             &
+                       .AND.        BTEST(wall_flags_0(k,j-1,i),0)             &
+                            )                       .OR.                       &
+                            ( .NOT. BTEST(wall_flags_0(k,j-2,i),0)             &
+                       .AND.        BTEST(wall_flags_0(k,j+1,i),0)             &
+                       .AND.        BTEST(wall_flags_0(k,j+2,i),0)             &
+                       .AND.        BTEST(wall_flags_0(k,j-1,i),0)             &
+                            )                                                  &
+                                                    .OR.                       &
+                            ( ( inflow_s .OR. outflow_s .OR. nest_bound_s )    &
+                              .AND. j == nysv  )    .OR.                       &
+                            ( ( inflow_n .OR. outflow_n .OR. nest_bound_n )    &
+                              .AND. j == nyn-1 ) )                             &          
                    THEN
-                      wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 4 )
+                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 4 )
 !
 !--                WS5
-                   ELSEIF ( k > nzb_s_inner(j+1,i) .AND. k > nzb_s_inner(j+2,i)&
-                      .AND. k > nzb_s_inner(j+3,i) .AND. k > nzb_s_inner(j-1,i)&
-                      .AND. k > nzb_s_inner(j-2,i) )                           &
+                   ELSEIF ( BTEST(wall_flags_0(k,j+1,i),0)                     &
+                      .AND. BTEST(wall_flags_0(k,j+2,i),0)                     &
+                      .AND. BTEST(wall_flags_0(k,j+3,i),0)                     &
+                      .AND. BTEST(wall_flags_0(k,j-1,i),0)                     &
+                      .AND. BTEST(wall_flags_0(k,j-2,i),0) )                   &
                    THEN 
-                      wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 5 )
+                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 5 )
                    ENDIF
 ! 
 !--                scalar - z-direction
 !--                WS1 (6), WS3 (7), WS5 (8)
+                   IF ( k == nzb+1 )  THEN
+                      k_mm = nzb
+                   ELSE 
+                      k_mm = k - 2
+                   ENDIF
+                   IF ( k > nzt-1 )  THEN
+                      k_pp = nzt+1
+                   ELSE 
+                      k_pp = k + 2
+                   ENDIF
+                   IF ( k > nzt-2 )  THEN
+                      k_ppp = nzt+1
+                   ELSE 
+                      k_ppp = k + 3
+                   ENDIF
+
                    flag_set = .FALSE.
-                   IF ( k == nzb_s_inner(j,i) + 1 .OR. k == nzt )  THEN
-                      wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 6 )
+                   IF ( .NOT. BTEST(wall_flags_0(k-1,j,i),0)  .AND.            &
+                              BTEST(wall_flags_0(k,j,i),0)    .OR.             &
+                        .NOT. BTEST(wall_flags_0(k_pp,j,i),0) .AND.            &                              
+                              BTEST(wall_flags_0(k,j,i),0)    .OR.             &
+                        k == nzt )                                             &
+                   THEN
+                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 6 )
                       flag_set = .TRUE.
-                   ELSEIF ( k == nzb_s_inner(j,i) + 2 .OR. k == nzt - 1 )  THEN
-                      wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 7 )
+                   ELSEIF ( ( .NOT. BTEST(wall_flags_0(k_mm,j,i),0)    .OR.    &
+                              .NOT. BTEST(wall_flags_0(k_ppp,j,i),0) ) .AND.   & 
+                                  BTEST(wall_flags_0(k-1,j,i),0)  .AND.        &
+                                  BTEST(wall_flags_0(k,j,i),0)    .AND.        &
+                                  BTEST(wall_flags_0(k+1,j,i),0)  .AND.        &
+                                  BTEST(wall_flags_0(k_pp,j,i),0) .OR.         &    
+                            k == nzt - 1 )                                     &
+                   THEN
+                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 7 )
                       flag_set = .TRUE.
-                   ELSEIF ( k > nzb_s_inner(j,i) .AND. .NOT. flag_set )  THEN
-                      wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 8 )
+                   ELSEIF ( BTEST(wall_flags_0(k_mm,j,i),0)                    &
+                     .AND.  BTEST(wall_flags_0(k-1,j,i),0)                     &
+                     .AND.  BTEST(wall_flags_0(k,j,i),0)                       &
+                     .AND.  BTEST(wall_flags_0(k+1,j,i),0)                     &
+                     .AND.  BTEST(wall_flags_0(k_pp,j,i),0)                    &
+                     .AND.  BTEST(wall_flags_0(k_ppp,j,i),0)                   &
+                     .AND. .NOT. flag_set )                                    &
+                   THEN
+                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 8 )
                    ENDIF
 
@@ -520,7 +569,7 @@
        IF ( momentum_advec == 'ws-scheme' )  THEN
 !
-!--       Set wall_flags_0 to steer the degradation of the advection scheme in advec_ws
+!--       Set advc_flags_1 to steer the degradation of the advection scheme in advec_ws
 !--       near topography, inflow- and outflow boundaries as well as bottom and
-!--       top of model domain. wall_flags_0 remains zero for all non-prognostic
+!--       top of model domain. advc_flags_1 remains zero for all non-prognostic
 !--       grid points.
           DO  i = nxl, nxr
@@ -532,10 +581,10 @@
 !--                in order to handle the left/south flux.
 !--                near vertical walls. 
-                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 9 )
-                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 12 )
+                   advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 9 )
+                   advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 12 )
 !
 !--                u component - x-direction
 !--                WS1 (9), WS3 (10), WS5 (11)
-                   IF ( k <= nzb_u_inner(j,i+1)     .OR.                       &
+                   IF ( .NOT. BTEST(wall_flags_0(k,j,i+1),1)  .OR.             &
                             ( ( inflow_l .OR. outflow_l .OR. nest_bound_l )    &
                               .AND. i <= nxlu  )    .OR.                       &
@@ -543,8 +592,8 @@
                               .AND. i == nxr   ) )                             &
                    THEN
-                       wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 9 )
-                   ELSEIF ( ( k <= nzb_u_inner(j,i+2) .AND.                    &
-                              k >  nzb_u_inner(j,i+1) ) .OR.                   &
-                              k <= nzb_u_inner(j,i-1)                          &
+                       advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 9 )
+                   ELSEIF ( ( .NOT. BTEST(wall_flags_0(k,j,i+2),1)  .AND.      &
+                                    BTEST(wall_flags_0(k,j,i+1),1)  .OR.       &
+                              .NOT. BTEST(wall_flags_0(k,j,i-1),1) )           &
                                                         .OR.                   &
                             ( ( inflow_r .OR. outflow_r .OR. nest_bound_r )    &
@@ -553,20 +602,21 @@
                               .AND. i == nxlu+1) )                             &
                    THEN
-                      wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 10 )
+                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 10 )
 !
 !--                   Clear flag for WS1
-                      wall_flags_0(k,j,i) = IBCLR( wall_flags_0(k,j,i), 9 )
-                   ELSEIF ( k > nzb_u_inner(j,i+1) .AND. k > nzb_u_inner(j,i+2)   &
-                                                   .AND. k > nzb_u_inner(j,i-1) ) &
+                      advc_flags_1(k,j,i) = IBCLR( advc_flags_1(k,j,i), 9 )
+                   ELSEIF ( BTEST(wall_flags_0(k,j,i+1),1)  .AND.              &
+                            BTEST(wall_flags_0(k,j,i+2),1)  .AND.              &
+                            BTEST(wall_flags_0(k,j,i-1),1) )                   &
                    THEN    
-                      wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 11 )
+                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 11 )
 !
 !--                   Clear flag for WS1
-                      wall_flags_0(k,j,i) = IBCLR( wall_flags_0(k,j,i), 9 )
+                      advc_flags_1(k,j,i) = IBCLR( advc_flags_1(k,j,i), 9 )
                    ENDIF
 !
 !--                u component - y-direction
 !--                WS1 (12), WS3 (13), WS5 (14)
-                   IF ( k <= nzb_u_inner(j+1,i) .OR.                           &
+                   IF ( .NOT. BTEST(wall_flags_0(k,j+1,i),1)   .OR.            &
                             ( ( inflow_s .OR. outflow_s .OR. nest_bound_s )    &
                               .AND. j == nys   )    .OR.                       &
@@ -574,8 +624,8 @@
                               .AND. j == nyn   ) )                             &
                    THEN
-                      wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 12 )
-                   ELSEIF ( ( k <= nzb_u_inner(j+2,i) .AND.                    &
-                              k >  nzb_u_inner(j+1,i) ) .OR.                   &
-                              k <= nzb_u_inner(j-1,i)                          &
+                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 12 )
+                   ELSEIF ( ( .NOT. BTEST(wall_flags_0(k,j+2,i),1)  .AND.      &
+                                    BTEST(wall_flags_0(k,j+1,i),1)  .OR.       &
+                              .NOT. BTEST(wall_flags_0(k,j-1,i),1) )           &
                                                         .OR.                   &
                             ( ( inflow_s .OR. outflow_s .OR. nest_bound_s )    &
@@ -584,28 +634,64 @@
                               .AND. j == nyn-1 ) )                             &
                    THEN
-                      wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 13 )
+                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 13 )
 !
 !--                   Clear flag for WS1
-                      wall_flags_0(k,j,i) = IBCLR( wall_flags_0(k,j,i), 12 )
-                   ELSEIF ( k > nzb_u_inner(j+1,i) .AND. k > nzb_u_inner(j+2,i)   &
-                                                   .AND. k > nzb_u_inner(j-1,i) ) &
+                      advc_flags_1(k,j,i) = IBCLR( advc_flags_1(k,j,i), 12 )
+                   ELSEIF ( BTEST(wall_flags_0(k,j+1,i),1)  .AND.              &
+                            BTEST(wall_flags_0(k,j+2,i),1)  .AND.              &
+                            BTEST(wall_flags_0(k,j-1,i),1) )                   &
                    THEN
-                      wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 14 )
+                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 14 )
 !
 !--                   Clear flag for WS1
-                      wall_flags_0(k,j,i) = IBCLR( wall_flags_0(k,j,i), 12 )
+                      advc_flags_1(k,j,i) = IBCLR( advc_flags_1(k,j,i), 12 )
                    ENDIF
 !
 !--                u component - z-direction
 !--                WS1 (15), WS3 (16), WS5 (17)
+                   IF ( k == nzb+1 )  THEN
+                      k_mm = nzb
+                   ELSE 
+                      k_mm = k - 2
+                   ENDIF
+                   IF ( k > nzt-1 )  THEN
+                      k_pp = nzt+1
+                   ELSE 
+                      k_pp = k + 2
+                   ENDIF
+                   IF ( k > nzt-2 )  THEN
+                      k_ppp = nzt+1
+                   ELSE 
+                      k_ppp = k + 3
+                   ENDIF                   
+
                    flag_set = .FALSE.
-                   IF ( k == nzb_u_inner(j,i) + 1 .OR. k == nzt )  THEN
-                      wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 15 )
+                   IF ( .NOT. BTEST(wall_flags_0(k-1,j,i),1)  .AND.            &
+                              BTEST(wall_flags_0(k,j,i),1)    .OR.             &
+                        .NOT. BTEST(wall_flags_0(k_pp,j,i),1) .AND.            &                              
+                              BTEST(wall_flags_0(k,j,i),1)    .OR.             &
+                        k == nzt )                                             &
+                   THEN
+                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 15 )
+                      flag_set = .TRUE.                      
+                   ELSEIF ( ( .NOT. BTEST(wall_flags_0(k_mm,j,i),1)    .OR.    &
+                              .NOT. BTEST(wall_flags_0(k_ppp,j,i),1) ) .AND.   & 
+                                  BTEST(wall_flags_0(k-1,j,i),1)  .AND.        &
+                                  BTEST(wall_flags_0(k,j,i),1)    .AND.        &
+                                  BTEST(wall_flags_0(k+1,j,i),1)  .AND.        &
+                                  BTEST(wall_flags_0(k_pp,j,i),1) .OR.         &
+                                  k == nzt - 1 )                               &
+                   THEN
+                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 16 )
                       flag_set = .TRUE.
-                   ELSEIF ( k == nzb_u_inner(j,i) + 2 .OR. k == nzt - 1 )  THEN
-                      wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 16 )
-                      flag_set = .TRUE.
-                   ELSEIF ( k > nzb_u_inner(j,i) .AND. .NOT. flag_set )  THEN
-                      wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 17 )
+                   ELSEIF ( BTEST(wall_flags_0(k_mm,j,i),1)  .AND.             &
+                            BTEST(wall_flags_0(k-1,j,i),1)   .AND.             &
+                            BTEST(wall_flags_0(k,j,i),1)     .AND.             &
+                            BTEST(wall_flags_0(k+1,j,i),1)   .AND.             &
+                            BTEST(wall_flags_0(k_pp,j,i),1)  .AND.             &
+                            BTEST(wall_flags_0(k_ppp,j,i),1) .AND.             &
+                            .NOT. flag_set )                                   &
+                   THEN
+                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 17 )
                    ENDIF
 
@@ -621,10 +707,10 @@
 !--                Since fluxes are swapped in advec_ws.f90, this is necessary to 
 !--                in order to handle the left/south flux.
-                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 18 )
-                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 21 )
+                   advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 18 )
+                   advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 21 )
 !
 !--                v component - x-direction
 !--                WS1 (18), WS3 (19), WS5 (20)
-                   IF ( k <= nzb_v_inner(j,i+1) .OR.                           &
+                   IF ( .NOT. BTEST(wall_flags_0(k,j,i+1),2)  .OR.             &
                             ( ( inflow_l .OR. outflow_l .OR. nest_bound_l )    &
                               .AND. i == nxl   )    .OR.                       &
@@ -632,10 +718,10 @@
                               .AND. i == nxr   ) )                             &
                   THEN
-                      wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 18 )
+                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 18 )
 !
 !--                WS3
-                   ELSEIF ( ( k <= nzb_v_inner(j,i+2) .AND.                    &
-                              k >  nzb_v_inner(j,i+1) ) .OR.                   &
-                              k <= nzb_v_inner(j,i-1)                          &
+                   ELSEIF ( ( .NOT. BTEST(wall_flags_0(k,j,i+2),2)   .AND.     &
+                                    BTEST(wall_flags_0(k,j,i+1),2) ) .OR.      &
+                              .NOT. BTEST(wall_flags_0(k,j,i-1),2)             &
                                                     .OR.                       &
                             ( ( inflow_r .OR. outflow_r .OR. nest_bound_r )    &
@@ -644,20 +730,21 @@
                               .AND. i == nxlu  ) )                             &
                    THEN
-                      wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 19 )
+                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 19 )
 !
 !--                   Clear flag for WS1
-                      wall_flags_0(k,j,i) = IBCLR( wall_flags_0(k,j,i), 18 )
-                   ELSEIF ( k > nzb_v_inner(j,i+1) .AND. k > nzb_v_inner(j,i+2)   &
-                                                   .AND. k > nzb_v_inner(j,i-1) ) &
+                      advc_flags_1(k,j,i) = IBCLR( advc_flags_1(k,j,i), 18 )
+                   ELSEIF ( BTEST(wall_flags_0(k,j,i+1),2)  .AND.              &
+                            BTEST(wall_flags_0(k,j,i+2),2)  .AND.              &
+                            BTEST(wall_flags_0(k,j,i-1),2) )                   &
                    THEN
-                      wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 20 )
+                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 20 )
 !
 !--                   Clear flag for WS1
-                      wall_flags_0(k,j,i) = IBCLR( wall_flags_0(k,j,i), 18 )
+                      advc_flags_1(k,j,i) = IBCLR( advc_flags_1(k,j,i), 18 )
                    ENDIF
 !
 !--                v component - y-direction
 !--                WS1 (21), WS3 (22), WS5 (23)
-                   IF ( k <= nzb_v_inner(j+1,i) .OR.                           &
+                   IF ( .NOT. BTEST(wall_flags_0(k,j+1,i),2) .OR.              &
                             ( ( inflow_s .OR. outflow_s .OR. nest_bound_s )    &
                               .AND. j <= nysv  )    .OR.                       &
@@ -665,8 +752,8 @@
                               .AND. j == nyn   ) )                             &
                    THEN
-                      wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 21 )
-                   ELSEIF ( ( k <= nzb_v_inner(j+2,i) .AND.                    &
-                              k >  nzb_v_inner(j+1,i) ) .OR.                   &
-                              k <= nzb_v_inner(j-1,i)                          &
+                      advc_flags_1(k,j,i) = IBSET( advc_flags_1(k,j,i), 21 )
+                   ELSEIF ( ( .NOT. BTEST(wall_flags_0(k,j+2,i),2)  .AND.      &
+                                    BTEST(wall_flags_0(k,j+1,i),2)  .OR.       &
+                              .NOT. BTEST(wall_flags_0(k,j-1,i),2) )           &
                                                         .OR.                   &
                             ( ( inflow_s .OR. outflow_s .OR. nest_bound_s )    &
